<?php

namespace Teknisa\ACL\Repositories;

use Doctrine\DBAL\Connection;
use Doctrine\DBAL\DBALException;
use Teknisa\ACL\Util\InstanceProvider;


class GrupoOperador {

    public function findOpergrupop($cdoperador): array
    {
        $query ="
            SELECT O.NRORG, O.CDOPERADOR, O.CDGRUPOPER, G.DSGRUPOPER, O.IDMENUPRINOP
                  FROM OPERGRUPOP O, GRUPOPER G
                 WHERE O.CDGRUPOPER = G.CDGRUPOPER 
                   AND O.CDOPERADOR = :CDOPERADOR";

        $params = array(
            "CDOPERADOR" => $cdoperador
        );
        $std = InstanceProvider::getEntityManager()->getConnection()->prepare($query);
        $std->execute($params);
        return $std->fetchAll();

    }

    /**
     * @param $cdoperador
     * @param $nrperfilacesso
     * @return mixed[]
     */
    public function findGrupooperByGrupopcont($cdoperador, $nrperfilacesso): array
    {
        $query ="
                SELECT G.CDGRUPOPER, GR.DSGRUPOPER, G.NRPERFILACESSO, G.NRORG
                  FROM GRUPOPCONT   G
                  JOIN GRUPOPER GR ON G.CDGRUPOPER = GR.CDGRUPOPER
                                  AND G.NRORG = GR.NRORG
                 WHERE G.CDGRUPOPER NOT IN (SELECT CDGRUPOPER 
                                              FROM OPERGRUPOP
                                             WHERE CDOPERADOR =:CDOPERADOR)
                   AND G.NRPERFILACESSO = :NRPERFILACESSO
                ORDER BY G.CDGRUPOPER, GR.DSGRUPOPER, G.NRPERFILACESSO, G.NRORG" ;

        $params = array(
            "CDOPERADOR" => $cdoperador,
            'NRPERFILACESSO' => $nrperfilacesso
        );
        $std = InstanceProvider::getEntityManager()->getConnection()->prepare($query);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function findGrupooperNotInOperGrupOp($cdoperador)
    {
        $query ="
               SELECT G.CDGRUPOPER, G.DSGRUPOPER, G.NRORG
                  FROM GRUPOPER   G
                 WHERE G.CDGRUPOPER NOT IN (SELECT CDGRUPOPER 
                                              FROM OPERGRUPOP
                                             WHERE CDOPERADOR =:CDOPERADOR)
                   AND G.IDATIVO = 'S'
                ORDER BY G.CDGRUPOPER, G.DSGRUPOPER, G.NRORG" ;

        $params = array(
            "CDOPERADOR" => $cdoperador,
        );
        $std = InstanceProvider::getEntityManager()->getConnection()->prepare($query);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function updateOpergrupop($idmenuprinop, $cdgrupoper, $cdoperador)
    {
        $query = "
               UPDATE OPERGRUPOP
                  SET IDMENUPRINOP = :IDMENUPRINOP
                WHERE CDGRUPOPER = :CDGRUPOPER 
                  AND CDOPERADOR = :CDOPERADOR";

        $params = array(
            "IDMENUPRINOP" => $idmenuprinop,
            "CDGRUPOPER" => $cdgrupoper,
            "CDOPERADOR" => $cdoperador
        );

        try {
            $std = InstanceProvider::getEntityManager()->getConnection()->prepare($query);
            $std->execute($params);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        };
    }


}
